<?php
// Copyright (C) 2008 - 2019 Small Green Computer, LLC
//

// Set the PHP timezone. We get a lot of errors if we don't do this.
$CurrentTimeZone = exec("/usr/bin/timedatectl | grep 'Time zone:' |  awk '{ print $3 }'");
date_default_timezone_set($CurrentTimeZone);

// Avalible audio services
$serviceList = array(	'squeezelite0' => 'SqueezeLite',
						'shairport' => 'AirPlay',
						'gmediarender' => 'DLNA',
						'mpd' => 'MPD'); 

// Get a system varables
function getSysVar($sysVar)
{	
  switch ($sysVar) {
    case 'dateTimeNow':
		$sysVarValue = date("m/d/Y g:i:s A", time());
        break;
    case 'Hostname':
		$sysVarValue = trim(exec('/usr/bin/hostname -s'));
        break;
    case 'MacAddress':
		$sysVarValue = strtoupper(fget_contents('/sys/class/net/eth0/address'));
        break;
	case 'IPaddress':
		$sysVarValue = exec("/sbin/ifconfig eth0 | grep inet | awk '{print $2}' | sed  's/addr://' | head -1");
		if ($sysVarValue == "") { $sysVarValue = exec("/sbin/ifconfig | grep inet | awk '{print $2}' | sed  's/addr://' | head -1");}
        break;
    case 'SqueezeLiteVersion':
		$sysVarValue = exec("/usr/bin/squeezelite -h | head -1 | gawk '{print $2}' | sed -e 's/,$//'");
		break;
    case 'MPDVersion':
		$sysVarValue = trim(exec("/usr/bin/mpd -V | head -1 | gawk '{print $6}'"));
        break;
    case 'DLNAVersion':
		$sysVarValue = trim(exec("/usr/bin/gmediarender --version | head -1 | gawk '{print $3}'"));
        break;
	case 'FedoraVersion':
		$sysVarValue = fget_contents('/etc/fedora-release');
        break;	
    case 'VortexBoxVersion':
		$sysVarValue = fget_contents('/etc/vortexbox/vortexbox-version');
        break;
    case 'audioStatus':
		$sysVarValue = fget_contents('/proc/asound/card0/stream0');
		if ($sysVarValue == 'UNKNOWN') {
			$sysVarValue = "Not avalible.";
		} else {
			$sysVarValue = nl2br($sysVarValue);
		}
        break;
    case 'audioHardwareStatus':
		$sysVarValue = fget_contents('/proc/asound/card0/pcm0p/sub0/hw_params');
		if ($sysVarValue == 'UNKNOWN') {
			$sysVarValue = "Not avalible.";
		} else {
			$sysVarValue = nl2br($sysVarValue);
		}
        break;
    case 'EnabledService':
		$sysVarValue = fget_contents('/etc/vamp/start_player');
        break;
    case 'storageMount':
		$storageInfo = exec('/usr/bin/mount | grep /storage');
		if ($storageInfo == '')
		{
			$sysVarValue = 'No NFS mount.';
		} else {
			$storageInfoIP = explode(':', $storageInfo);
			$sysVarValue = trim($storageInfoIP[0]);
		}
        break;		
	default:
       $sysVarValue = 'ERROR: '.$sysVar.' does not exist.';		
  }
  return $sysVarValue;
}

// Get Service status information
function serviceStatus($service)
{
	$rawStatus = trim(exec('/usr/bin/systemctl status '.$service.' | grep Active:'));
	$Status = explode(' ', $rawStatus);
	switch ($Status[1]) {
      case 'active':
		$serviceStatus = '<span class="label label-success">Active</span>';
        break;
      case 'inactive':
		$serviceStatus = '<span class="label label-important">Stopped</span>';
        break;		
	  default:
       $serviceStatus = '<span class="label">UNKNOWN</span>';		
	}		
	return $serviceStatus;
}
?>