<?php
// Copyright (C) 2008 - 2019 Small Green Computer, LLC
//

require_once 'libs/setup.php';

$configfile = "/var/www/html/config/minidlna.cfg";
$minidlnaconf = "/var/tmp/minidlna.conf";

$_action = isset($_REQUEST['action']) ? $_REQUEST['action'] : 'default';
$config = array();

if (file_exists($configfile)) {
    $config = array();
} else {
// build default if required
    $config = array( "AUDIOFILES" => "/storage/music/mp3", "VIDEOFILES" => "/storage/movies", "PICTUREFILES" => "/storage/pictures", "DESCRIPTION" => "MiniDLNA Media Server");

	$fp = fopen($configfile,'w');
	fwrite($fp,serialize($config));
	fclose($fp);	
}
	
switch($_action) {

    case 'submit':

		if (isset($_REQUEST['AUDIOFILES']) & !$_REQUEST['AUDIOFILES'] =="") { $config['AUDIOFILES'] = $_REQUEST['AUDIOFILES']; }
		if (isset($_REQUEST['VIDEOFILES']) & !$_REQUEST['VIDEOFILES'] =="") { $config['VIDEOFILES'] = $_REQUEST['VIDEOFILES']; }
		if (isset($_REQUEST['PICTUREFILES']) & !$_REQUEST['PICTUREFILES'] =="") { $config['PICTUREFILES'] = $_REQUEST['PICTUREFILES']; }
		if (isset($_REQUEST['DESCRIPTION']) & !$_REQUEST['DESCRIPTION'] =="") { $config['DESCRIPTION'] = $_REQUEST['DESCRIPTION']; }

		$fp = fopen($configfile,'w');
		fwrite($fp,serialize($config));
		fclose($fp);
		
		$minidlnaConfigFileData = 'port=8200'."\n";
		if (isset($config['AUDIOFILES'])) {
			$minidlnaConfigFileData .= 'media_dir=A,'.$config['AUDIOFILES']."\n";
		};
		if (isset($config['VIDEOFILES'])) {
			$minidlnaConfigFileData .= 'media_dir=V,'.$config['VIDEOFILES']."\n";
		};
		if (isset($config['PICTUREFILES'])) {
			$minidlnaConfigFileData .= 'media_dir=P,'.$config['PICTUREFILES']."\n";
		};
		if (isset($config['DESCRIPTION'])) {
			$minidlnaConfigFileData .= 'friendly_name='.$config['DESCRIPTION']."\n";
		};	
		$minidlnaConfigFileData .= 'db_dir=/var/cache/minidlna'."\n";
		$minidlnaConfigFileData .= 'log_dir=/var/log/minidlna'."\n";
		$minidlnaConfigFileData .= 'album_art_names=Cover.jpg/cover.jpg/Folder.jpg/folder.jpg'."\n";
		$minidlnaConfigFileData .= 'inotify=yes'."\n";
		$minidlnaConfigFileData .= 'enable_tivo=no'."\n";
		$minidlnaConfigFileData .= 'strict_dlna=yes'."\n";
		$minidlnaConfigFileData .= 'notify_interval=900'."\n";
		$minidlnaConfigFileData .= 'serial=12345678'."\n";
		$minidlnaConfigFileData .= 'model_number=2.3'."\n";
		
		$fp = fopen($minidlnaconf,'w');
		fwrite($fp,$minidlnaConfigFileData);
		fclose($fp);
			
		exec("sudo /opt/vortexbox/doaction.sh RestartDLNA & >/dev/null 2>&1");
	
		break;

	case 'RescanDLNA':
		exec("sudo /opt/vortexbox/doaction.sh RescanDLNA & >/dev/null 2>&1");
        break;

	case 'ResetDefaults':
		$config = array( "AUDIOFILES" => "/storage/music/mp3", "VIDEOFILES" => "/storage/movies", "PICTUREFILES" => "/storage/pictures", "DESCRIPTION" => "MiniDLNA Media Server" );
		$fp = fopen($configfile,'w');
		fwrite($fp,serialize($config));
		fclose($fp);
        break;
		
	case 'ClearDLNALog':
		exec("sudo /opt/vortexbox/doaction.sh ClearDLNALog & >/dev/null 2>&1");
        break;		
	
	default:
}

$configall = file_get_contents($configfile);
$config = unserialize($configall); 

foreach ($config as $key => $value) {
   $smarty->assign($key,$value);
}

$smarty->display('minidlna.tpl');
?>